/***********************************************
* Programa 3 del examen final (Junio - 2007)   *
* de Fundamentos de informtica (1 Ing. Ind.) *
* By: Eugenio Lzaro C.-A.                     *
***********************************************/

# include <stdio.h>
# include <stdlib.h>
# include <conio.h>
# include <string.h>
# include <ctype.h>
# include <math.h>
# include <time.h>

# define SI 1
# define NO 0
# define N 120
# define M 24
# define NL printf("\n")
# define NT printf("\n\t")
# define T printf("\t")
# define BB printf("\b")
# define FF fflush(stdin)
# define CLS system("cls")
# define FINOPCION NT; printf("Pulse cualquier tecla para continuar."); getche();

typedef struct
{
	int long codigo;
	char cadena[112];
} T_MOVS;

int BuscarCliente(int long cod_cli[], int no_clientes, int long codigo);

int main(void)
{
	FILE *fclientes;
	FILE *fmovimientos, *fmovsbuenos, *fmovsmalos;
	T_MOVS movimiento;
	int ctrl, i, cliente_ok, regs_buenos, regs_malos;
	int long cod_cli[100];
	int no_clientes;
	char mas;

// Se muestra un listado previo de los movimientos.
	CLS;
	NT;
	printf("Listado previo de movimientos de clientes");
	NT;
	printf("-----------------------------------------");
	NL; NT;
	fmovimientos = fopen("Movimientos.dat", "rb");
	ctrl = fread(&movimiento, sizeof(T_MOVS), 1, fmovimientos);
	while (ctrl == 1)
	{
		NT;
		printf("Codigo.......: %ld", movimiento.codigo);
		NT;
		printf("Resto de inf.: %s", movimiento.cadena);
		ctrl = fread(&movimiento, sizeof(T_MOVS), 1, fmovimientos);
		printf("\n\tCtrl = %d", ctrl);
	}
	printf("\n\tEOF = %d", EOF);
	fclose(fmovimientos);
	NL; NT;
	printf("... F I N   D E   L I S T A D O ...");
	NT;
	printf("Pulse cualquier tecla para depurar los movimientos");
	NT;
	printf("..................................................");
	getche();

// Comienzo del proceso de depurado (bucle genereal no necesario).
	do
	{

// Carga del vector con los cdigos de los clientes.
		fclientes = fopen("Cod_cli.txt", "r");
		if (fclientes == NULL)
		{
			NL; NT;
			printf("ERROR FATAL 1 con Cod_cli.txt");
			NT;
			printf("Avise al administrador del sistema.");
		}
		else
		{
			i = 0;
			ctrl = fscanf(fclientes, "%ld", &cod_cli[i]);
			while (ctrl == 1) // tambin (ctrl != EOF)
			{
				i++;
				ctrl = fscanf(fclientes, "%ld", &cod_cli[i]);
				printf("\n\tCtrl = %d", ctrl);
			}
			no_clientes = i;
			if (fclose(fclientes) != 0)
// Fin de carga del vector de cdigos de clientes.

			{
				NL; NT;
				printf("ERROR FATAL 2 con Cod_cli.txt");
				NT;
				printf("Avise al administrador del sistema.");
			}
			else
			{

// Comienzo del proceso de registros de movimientos de clientes.
				fmovimientos = fopen("Movimientos.dat", "rb");
				if (fmovimientos == NULL)
				{
					NL; NT;
					printf("ERROR FATAL 3 con Movimientos.dat");
					NT;
					printf("Avise al administrador del sistema.");
				}
				else
				{
// Apertura de los dems ficheros (MovsBuenos.dat y MovsMalos.dat).
					fmovsbuenos = fopen("MovsBuenos.dat", "wb");
					fmovsmalos = fopen("MovsMalos.dat", "wb");
					if (fmovsbuenos == NULL || fmovsmalos == NULL)
					{
						NL; NT;
						printf("ERROR FATAL 4 en MovsBuenos.dat y/o MovsMalos.dat");
						NT;
						printf("Avise al administrador del sistema.");
					}
					else
					{
// Contadores de registros "buenos" y "malos" a cero.
						regs_buenos = 0;
						regs_malos = 0;
// Procesamiento del fichero de movimientos. Lectura inicial.
						ctrl = fread(&movimiento, sizeof(T_MOVS), 1, fmovimientos);
						while (ctrl != 0) // && ctrl != EOF
						{
							cliente_ok = BuscarCliente(cod_cli, no_clientes, movimiento.codigo);
							if (cliente_ok == SI)
							{
								fwrite(&movimiento, sizeof(T_MOVS), 1, fmovsbuenos);
								regs_buenos++;
							}
							else
							{
								fwrite(&movimiento, sizeof(T_MOVS), 1, fmovsmalos);
								regs_malos++;
							}
// Procesamiento del fichero de movimientos. Lectura del bucle.
							ctrl = fread(&movimiento, sizeof(T_MOVS), 1, fmovimientos);
						}
						if (fclose(fmovsbuenos) != 0 || fclose(fmovsmalos) != 0)
// Fin del procesamiento del fichero de movimientos.
						{
							NL; NT;
							printf("ERROR FATAL 5 en MovsBuenos.dat y/o MovsMalos.dat");
							NT;
							printf("Avise al administrador del sistema.");
						}
						else
						{
							NL; NT;
							printf("Proceso terminado correctamente");
							NT;
							printf("Grabados %1d registros buenos y %1d registros malos", 
														regs_buenos, regs_malos);
						}
					}
				}
			}
		}
		NL; NT;
		printf("Si desea repetir el proceso pulse 's': ");
		FF;
		mas = getche();
	} while (mas == 's' || mas == 'S');
}

int BuscarCliente(int long cod_cli[], int no_clientes, int long codigo)
{
	int i;
	int encontrado;

// Control de bsqueda. Inicialmente NO.
	encontrado = NO;
	for (i = 0; i < no_clientes; i++)
	{
// Control de bsqueda. Si se encuentra SI.
		if (cod_cli[i] == codigo)
			encontrado = SI;
	}
	return encontrado;
}
