
	
/***********************************************************************************/
int New_Salesrep (T_SALESREP new_salesrep)
{
	FILE *p_sales;				// pointer associated to salesreps.dat
    T_SALESREP salesrep;		// structure of T_SALESREP type
	int n_records;				// number of records before addition
	int position;				// position to insert the new salesrep
	long int displacement;		// displacement in function fseek()
	int i;						// loop control variable
	int result;					// holding value returned to function
	
	// Determining number of records in the file
	n_records = Count_Records();
	
	// Determining the position in the file of the new salesperson
	position = Find_Position(new_salesrep);
    
	if (position<0)
	{
		result=0;
	}
	else
	{
		// Reorginizing the file with the new salesrep	
		// We move all the records one record forward starting from the last
		// record including the record that is going to be right after the 
		// one to be inserted.
		// The number of forward movements is n_records_position
		
		p_sales = fopen("salesreps.dat","r+b");
		if (p_sales==NULL)
		{
			printf("\nError. Cannot open designated file");			
		}
		else
		{
			/*
			// Referencing with SEEK_SET			
			for (i=1; i<=n_records-position; i++)   
			{				
				displacement = (n_records-i) * sizeof (T_SALESREP);			
				fseek (p_sales, displacement, SEEK_SET);
				fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);			
				displacement = (n_records-i+1) * sizeof (T_SALESREP);			
				fseek (p_sales, displacement, SEEK_SET);
				fwrite(&salesrep, sizeof(T_SALESREP), 1, p_sales);					
			}
			*/
			// Referencing with SEEK_END
			/*
			for (i=1; i<=n_records-position; i++)   
			{
				if(i==1)
				{
					displacement = (-1)*i*sizeof (T_SALESREP);			
					fseek (p_sales, displacement, SEEK_END);
					fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);			
					displacement = (-1)*(i-1)* sizeof (T_SALESREP);			
					fseek (p_sales, displacement, SEEK_END);
					fwrite(&salesrep, sizeof(T_SALESREP), 1, p_sales);
				}
				else
				// For the next movements take into account the fact 
				// that the file has now an additional record
				// and then a new reference for SEEK_END
				{
					displacement = (-1)*(i+1)*sizeof (T_SALESREP);			
					fseek (p_sales, displacement, SEEK_END);
					fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);			
					displacement = (-1)*i* sizeof (T_SALESREP);			
					fseek (p_sales, displacement, SEEK_END);
					fwrite(&salesrep, sizeof(T_SALESREP), 1, p_sales);	
				}
			}				
			*/

			// Referencing with SEEK_CURRENT
			for (i=1; i<=n_records-position; i++)   
			{			
				if (i==1)
				{
					displacement = (n_records-1)*sizeof(T_SALESREP);
				}
				else
				{
					displacement = (-3)*sizeof (T_SALESREP);
				}
				fseek (p_sales, displacement, SEEK_CUR);
				fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);			
			    fseek (p_sales, 0, SEEK_CUR);
				fwrite(&salesrep, sizeof(T_SALESREP), 1, p_sales);
			}

			// Write the data of the new salesperson	
			displacement = position * sizeof(T_SALESREP);
			fseek (p_sales, displacement, SEEK_SET);
			fwrite(&new_salesrep, sizeof(T_SALESREP), 1, p_sales);
			fclose(p_sales);
			result = 1;
		}
	}	
	return result;
}
/*******************************************************************************/
int Count_Records ()
{
	FILE *p_sales;			// Pointer related to salesreps.dat
	T_SALESREP salesrep;	// Structure of T_SALESREP type
	int n_records=0;		// For counting the records presently in the file

	p_sales = fopen("salesreps.dat", "rb");
	if (p_sales==NULL)
	{
		printf("\nError. Cannot open designated file");		
	}
    else
	{		
		fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);
		while (!feof(p_sales))
		{		
			n_records++;
			fread(&salesrep, sizeof(T_SALESREP), 1, p_sales);
		}
		fclose(p_sales);
	}
	return(n_records);
}
/**************************************************************************************/
int Find_Position (T_SALESREP newsales)
{
	FILE *p_sales;			// Pointer related to salesreps.dat
	T_SALESREP salesrep;	// Structure of T_SALESREP type	
	int position;			// Position in the file to insert the new salerep 
	int found;				// Turns to 1 when position is found, to stop looping
		
	p_sales = fopen("salesreps.dat", "rb");
	if (p_sales==NULL)
	{
		printf("\nError. Cannot open designated file");		
	}
	else
	{
		found = 0;
		position = 0;
			
		while ((fread(&salesrep, sizeof(T_SALESREP), 1, p_sales)==1)
			&&(found==0))
		{				
			if(strcmp(salesrep.name, newsales.name)==0)		// Duplicated salesman
			{				
				found=1;
				position=-1;
			}
			// Name of the new salesrep is now "smaller" than the current salesrep in the file
			else if(strcmp(salesrep.name, newsales.name)>0)
			{
				found=1;
			}
			else
			{
				position++;								
			}
		}
		fclose(p_sales);
	}
	return position;
}
/**********************************************************************************/

